(**********************************************************************)
(* (c) Greg Morrisett, Neal Glew, David Walker,                       *)
(*     June 1998, all rights reserved.                                *)
(**********************************************************************)

open Ycalculus
open Yprim
open Ycon
open Ident
open Format

exception Hack of string

let die s = (print_string "Hack failed: ";print_string s;print_string"\n";
             raise (Hack s))

let dumpye e = Ypp.print_term e; print_newline()

let entry_function entry_point =
  let c = YCabs ([], [YCconst YCint], YCconst YCint) in
  let x = new_ident () in
  let f = Yabs ([], [x,YCconst YCint], 
		Yapp(entry_point, [], [Yprim (Yunit,[],[]); Yvar x])) 
  in
  let fname = new_ident () in
  (fname, c, f)

let hack (YMstruct (c,e)) =
  let rec hack e =
  match e with
    Ylet (Ytypebind (v,c), e) ->
      Ylet (Ytypebind (v,c), hack e)
  | Ylet (Yrecbind fs, e) ->
      (match fs with
 	(x,c,f)::fs ->
	  let entry_point = 
	    (match f with
	      Yabs (_,_,Ylet (_,Ylet(Yvalbind (_,packexp),_))) ->
	      	(match packexp with
		  Ypack (Ytuple [entry_point;_],_,_,_,_) -> entry_point
		| _ -> die "not pack")
	    | _ -> dumpye f; die "not lets")
	  in
	  let (fname,c,f) as entry_function = entry_function entry_point in
	  Ylet (Yrecbind (entry_function::fs), Yvar fname)
      |	_ -> die "no functions")
  | _ -> die "not typebind or recbind"
  in
  YMstruct (YCabs([],[YCconst YCint], YCconst YCint), hack e)
