#ifndef PP_H
#define PP_H
/*
 * pp.cyc
 * Trevor Jim                                                         
 *                                                                    
 * Kamin's  version of Wadler's pretty printing combinators,          
 * extended to do hyperlinks for Tk.                                  
 */
#include "core.h"
#include "list.h"

namespace PP {
extern struct ppstate;
extern struct out;
extern struct doc;
typedef struct ppstate @Ppstate;
typedef struct out @Out;
typedef struct doc @Doc;
typedef $(int,int,int,string) @link; // line, char, length, link content

extern string string_of_doc(Doc d, int w);
extern $(string,List::list<link>)@ string_and_links(Doc d, int w);
extern Doc text(string s);
extern Doc nil_doc();
extern Doc blank_doc();
extern Doc hyperlink(string shrt, string full);
extern Doc line_doc();
extern Doc nest(int k, Doc d);
extern Doc concat(Doc d1, Doc d2);
extern Doc concats(List::list<Doc> doclist);
extern Doc doc_union(Doc d, Doc d2);
extern Doc oline_doc();
extern Doc tab(Doc d);
extern Doc ppseq<`a>(Doc pp(`a), string sep, List::list<`a> l0);
extern Doc seq(string sep, List::list<Doc> l0);
extern Doc ppseql<`a>(Doc pp(`a), string sep, List::list<`a> l0);
extern Doc seql(string sep, List::list<Doc> l0);
}
#endif
